<p align="center">
  <img src="https://weforge.xyz/Spitfire/Branding/raw/branch/main/active/browser/icon.svg" alt="Logo" width="64" height="64">
</p>

<p align="center" style="font-size: 32px;">
  <strong>Spitfire Builder</strong>
</p>

<p align="center">
This is a "simple" script for building the Spitfire Browser based on Mozilla Firefox source code.
</p>

## Dependencies

- Mercurial (hg)
- Git
- Golang (tested with v1.21)
- Python 3.11 and pip3

# Example usage:

## Build:

```sh
go run . -a
```

## Upload:

```sh
go run . --upload -c --upload-path=./mozilla-central/obj-x86_64-pc-linux-gnu/dist/bin
```

## Build and upload:

```sh
go run . --upload -c --upload-path=./mozilla-central/obj-x86_64-pc-linux-gnu/dist/bin -a
```

## Display all flags:

```sh
go run . -h
```

### Config file for uploading example:

*sourceforge_config.json*

```json
{
    "SFKeyPath": "~/.ssh/id_rsa.pub",
    "SFUser": "internet-addict",
    "SFHost": "web.sourceforge.net",
    "SFProject": "spitfire-browser"
}
```

## APPINDEX example:

```
C:905cd0cc2dea9e400e1ecd099462b6b19188a9f1
P:Spitfire
R:nightly
V:2024.09.08
A:amd64
S:788506622
I:3324483350
T:Spitfire build
U:https://spitfirebrowser.com/
L:AGPL-3.0
o:browser
m:Internet Addict
t:1725830641
c:905cd0cc2dea9e400e1ecd099462b6b19188a9f1
D:
p:linux
q:
Z:905cd0cc2dea9e400e1ecd099462b6b19188a9f1
```

## Repositary structure

```
spitfire-browser/
├── browser/
│   ├── amd64/
│   │   ├── stable/
│   │   │   ├── latest/deb.tar.gz
│   │   │   ├── x.x.x/deb.tar.gz
│   │   ├── nightly/
│   │       ├── latest/deb.tar.gz
│   │       ├── yyyy-mm-dd/deb.tar.gz
│   ├── arm/
│   │   ├── stable/
│   │   │   ├── latest/
│   │   │   ├── x.x.x/
│   │   ├── nightly/
│   │       ├── latest/
│   │       ├── yyyy-mm-dd/
├── cli-package-manager/
│   ├── stable/
│   │   ├── latest/
│   │   ├── x.x.x/
│   ├── nightly/
│       ├── latest/
│       ├── yyyy-mm-dd/
├── gui-installer/
│   ├── stable/
│   │   ├── latest/
│   │   ├── x.x.x/
│   ├── nightly/
│       ├── latest/
│       ├── yyyy-mm-dd/
├── gui-package-manager/
│   ├── stable/
│   │   ├── latest/
│   │   ├── x.x.x/
│   ├── nightly/
│       ├── latest/
│       ├── yyyy-mm-dd/
├── addons/
│   ├── themes/
│   │   ├── stable/
│   │   │   ├── latest/
│   │   │   ├── x.x.x/
│   │   ├── nightly/
│   │       ├── latest/
│   │       ├── yyyy-mm-dd/
│   ├── custom-configs/
│   │   ├── stable/
│   │   │   ├── latest/
│   │   │   ├── x.x.x/
│   │   ├── nightly/
│   │       ├── latest/
│   │       ├── yyyy-mm-dd/
│   ├── search-engines/
│       ├── stable/
│       │   ├── latest/
│       │   ├── x.x.x/
│       ├── nightly/
│           ├── latest/
│           ├── yyyy-mm-dd/
├── APPINDEX
```